package org.dromara.elevator.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.elevator.domain.EFaultMessage;
import org.springframework.stereotype.Service;
import org.dromara.elevator.domain.bo.EFunctionInfoBo;
import org.dromara.elevator.domain.vo.EFunctionInfoVo;
import org.dromara.elevator.domain.EFunctionInfo;
import org.dromara.elevator.mapper.EFunctionInfoMapper;
import org.dromara.elevator.service.IEFunctionInfoService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 职能部门信息;Service业务层处理
 *
 * @author zy
 * @date 2024-09-03
 */
@RequiredArgsConstructor
@Service
public class EFunctionInfoServiceImpl implements IEFunctionInfoService {

    private final EFunctionInfoMapper baseMapper;

    /**
     * 查询职能部门信息;
     *
     * @param id 主键
     * @return 职能部门信息;
     */
    @Override
    public EFunctionInfoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询职能部门信息;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 职能部门信息;分页列表
     */
    @Override
    public TableDataInfo<EFunctionInfoVo> queryPageList(EFunctionInfoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<EFunctionInfo> lqw = buildQueryWrapper(bo);
        Page<EFunctionInfoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的职能部门信息;列表
     *
     * @param bo 查询条件
     * @return 职能部门信息;列表
     */
    @Override
    public List<EFunctionInfoVo> queryList(EFunctionInfoBo bo) {
        LambdaQueryWrapper<EFunctionInfo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<EFunctionInfo> buildQueryWrapper(EFunctionInfoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<EFunctionInfo> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getName()), EFunctionInfo::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getAddress()), EFunctionInfo::getAddress, bo.getAddress());
        lqw.eq(StringUtils.isNotBlank(bo.getContacts()), EFunctionInfo::getContacts, bo.getContacts());
        lqw.eq(StringUtils.isNotBlank(bo.getContactsPhone()), EFunctionInfo::getContactsPhone, bo.getContactsPhone());
        lqw.eq(StringUtils.isNotBlank(bo.getAlarmPhone()), EFunctionInfo::getAlarmPhone, bo.getAlarmPhone());
        lqw.eq(StringUtils.isNotBlank(bo.getArea()), EFunctionInfo::getArea, bo.getArea());
        lqw.orderByDesc(EFunctionInfo::getCreateTime);
        return lqw;
    }

    /**
     * 新增职能部门信息;
     *
     * @param bo 职能部门信息;
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(EFunctionInfoBo bo) {
        EFunctionInfo add = MapstructUtils.convert(bo, EFunctionInfo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改职能部门信息;
     *
     * @param bo 职能部门信息;
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(EFunctionInfoBo bo) {
        EFunctionInfo update = MapstructUtils.convert(bo, EFunctionInfo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(EFunctionInfo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除职能部门信息;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
